#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "socket.h"

char buffer[1024];
int  MTU = 100;

int  port;
char* host;

Socket  *srv;
Socket  *sock;


void do_server(int p)
{
	int  len;

	srv = new Socket();
	if (!srv) {
		fprintf(stderr, "internal error 1\n");
		exit(1);
	}

	srv->Open("tcp", p);
	srv->Listen(1);
	printf("main server socket: fd=%d port=%d\n",
	       srv->sock(), srv->port());

	while (!srv->hasData(2000)) {
		fputc('.', stdout);
		fflush(stdout);
	}
	fputc('\n', stdout);
	fflush(stdout);

	sock = srv->Accept();
	if (!sock) {
		fprintf(stderr, "internal error 2\n");
		exit(1);
	}
	printf("accepting socket: fd=%d port=%d\n",
	       sock->sock(), sock->port());

	while (1) {
		len = sock->Recv(buffer, MTU);
		if (len <= 0)
			exit(0);
		printf("rcv: %s\n", buffer);
		len = sock->Send(buffer, MTU);
		if (len <= 0)
			exit(0);
	}
}

void do_client(const char *h, int p)
{
	int  len;

	sock = new Socket();
	if (!sock) {
		fprintf(stderr, "internal error 3\n");
		exit(1);
	}

	sock->Open("tcp", 0);
	printf("client socket (bef connection): fd=%d port=%d\n",
	       sock->sock(), sock->port());
	if (!sock->Connect(h, p)) {
		fprintf(stderr, "internal error 4\n");
		exit(1);
	}
	printf("client socket (aft connection): fd=%d port=%d\n",
	       sock->sock(), sock->port());

	sprintf(buffer, "my name is grigoris magklis");

	len = sock->Send(buffer, MTU);
	if (len <= 0)
		exit(1);
	len = sock->Recv(buffer, MTU);
	if (len <= 0)
		exit(1);
	printf("snd/rcv: %s\n", buffer);
	
	sock->Close();
}


int main(int argc, char** argv)
{
	--argc;
	++argv;

	// server
	if (argc == 1) {
		port = atoi(*argv);
		host = 0;
		do_server(port);
	}

	// client
	if (argc == 2) {
		host = strdup(*argv++);
		port = atoi(*argv);
		do_client(host, port);
	}
	
	if (argc == 0 || argc > 2) {
		fprintf(stderr, "usage: test_socket [host] port\n");
		exit(1);
	}

	return 0;
}
